
#include "common.h"
#include "Renderer.h"
#include "Texture.h"


static sys::Texture		texture;			// テクスチャ

/************
    初期化
 ************/
void	init_app(void)
{
	u8*		_buf = (u8*)sys::load_asset("photo.png");			// テクスチャ用PNG読み込み

	texture.load_png(_buf);					// テクスチャ設定
	free(_buf);
}

/******************************
    稼働
		戻り値	アプリ続行か
 ******************************/
Bool	update_app(void)
{
	static const
	float	texcoord[] =
			{
				0.0f, 0.0f,
				1.0f, 0.0f,
				0.0f, 1.0f,
				1.0f, 1.0f
			};

	static const
	float	vertex[] =
			{
				-320.0f, -480.0f,
				 320.0f, -480.0f,
				-320.0f,  480.0f,
				 320.0f,  480.0f,
			};

	static const
	GLubyte	color[] =
			{
				255, 255, 255, 255,
				255, 255, 255, 255,
				255, 255, 255, 255,
				255, 255, 255, 255,
			};

	sys::ShaderProgram*		_shader;

	_shader = sys::Renderer::use_shader(sys::Renderer::SHADER_TEXTURE);					// テクスチャ用シェーダ

	glBindTexture(GL_TEXTURE_2D, texture.texture);										// テクスチャ
	glVertexAttribPointer(_shader->texcoord, 2, GL_FLOAT, GL_FALSE, 0, texcoord);		// UV座標
	glVertexAttribPointer(_shader->position, 2, GL_FLOAT, GL_FALSE, 0, vertex);			// 頂点座標
	glVertexAttribPointer(_shader->color, 4, GL_UNSIGNED_BYTE, GL_TRUE, 0, color);		// カラー
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);

	return	TRUE;
}

/**************** End of File *************************************************/